/*
main.cpp
Written by Walter O. Krawec

Copyright (c) 2013 Walter O. Krawec

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include "QBL.h"

int main(int argc, char** argv)
{
	std::cout << "Quantum Behavioral Language v." << QBL_VERSION << "\nCopyright (c) 2013 Walter O. Krawec\nAll Rights Reserved.\n\n";
	qbl::QBL QBL;
#ifdef USE_VISUAL_DEBUG
	wok::NetRTGraphClient graphClient;
	QBL.setGraphClient(&graphClient);
#endif

	std::vector <wok::interp::CommandLibrary*> extras;

	/*
	Push new command libraries to "extras" to access wok::interp commands from QBL.  QBL itself is a command library for wok::interp.  Look at the class QBLCommands
	for an example on how to create a new command library.  Alternatively, if using Windows, use the load_module command to load a DLL command library
	*/

	if(argc == 1)
		QBL.shell(&extras);
	else
		QBL.evaluate(argv[1], &extras);

	/*
	Be sure to delete any extra command libraries you used before closing.
	*/

	return 0;
}